]> git.ipfire.org Git - people/teissler/ipfire-2.x.git/blob - make.sh
MPFire hinzugefĆ¼gt - CGI mpg123 Frontend
[people/teissler/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0t4" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 #ipfiremake linux XEN=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake klibc
353 ipfiremake mkinitcpio
354 ipfiremake udev KLIBC=1
355 ipfiremake expat
356 ipfiremake gdbm
357 ipfiremake gmp
358 ipfiremake pam
359 ipfiremake openssl
360 ipfiremake curl
361 ipfiremake python
362 ipfiremake libnet
363 ipfiremake libjpeg
364 ipfiremake libpng
365 ipfiremake libtiff
366 ipfiremake libart
367 ipfiremake freetype
368 ipfiremake gd
369 ipfiremake popt
370 ipfiremake pcre
371 ipfiremake slang
372 ipfiremake newt
373 ipfiremake libcap
374 ipfiremake pciutils
375 ipfiremake usbutils
376 ipfiremake libxml2
377 ipfiremake libxslt
378 ipfiremake BerkeleyDB
379 ipfiremake mysql
380 ipfiremake cyrus-sasl
381 ipfiremake openldap
382 ipfiremake apache2
383 ipfiremake php
384 ipfiremake apache2 PASS=C
385 ipfiremake arping
386 ipfiremake beep
387 ipfiremake bind
388 ipfiremake capi4k-utils
389 ipfiremake cdrtools
390 ipfiremake dnsmasq
391 ipfiremake dosfstools
392 ipfiremake reiserfsprogs
393 ipfiremake squashfstools
394 ipfiremake sysfsutils
395 ipfiremake ntfs-3g
396 ipfiremake ethtool
397 ipfiremake ez-ipupdate
398 ipfiremake fcron
399 ipfiremake GD
400 ipfiremake GD-Graph
401 ipfiremake GD-TextUtil
402 ipfiremake gnupg
403 ipfiremake hdparm
404 ipfiremake ibod
405 ipfiremake initscripts
406 ipfiremake whatmask
407 ipfiremake iptables
408 ipfiremake libupnp
409 ipfiremake ipp2p IPT=1
410 ipfiremake moblock
411 ipfiremake linux-igd
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 ipfiremake isdn4k-utils
418 ipfiremake mISDN
419 ipfiremake hwdata
420 ipfiremake kudzu
421 ipfiremake logrotate
422 ipfiremake logwatch
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nasm
427 ipfiremake URI
428 ipfiremake HTML-Tagset
429 ipfiremake HTML-Parser
430 ipfiremake Compress-Zlib
431 ipfiremake Digest
432 ipfiremake Digest-SHA1
433 ipfiremake Digest-HMAC
434 ipfiremake libwww-perl
435 ipfiremake Net-DNS
436 ipfiremake Net-IPv4Addr
437 ipfiremake Net_SSLeay
438 ipfiremake IO-Stringy
439 ipfiremake Unix-Syslog
440 ipfiremake Mail-Tools
441 ipfiremake MIME-Tools
442 ipfiremake Net-Server
443 ipfiremake Convert-TNEF
444 ipfiremake Convert-UUlib
445 ipfiremake Archive-Tar
446 ipfiremake Archive-Zip
447 ipfiremake Text-Tabs+Wrap
448 ipfiremake Locale-Country
449 ipfiremake XML-Parser
450 ipfiremake MP3-Info
451 ipfiremake MP3-Tag
452 ipfiremake glib
453 ipfiremake GeoIP
454 ipfiremake fwhits
455 ipfiremake noip_updater
456 ipfiremake ntp
457 ipfiremake openssh
458 ipfiremake openswan
459 ipfiremake pptpclient
460 ipfiremake rrdtool
461 ipfiremake setserial
462 ipfiremake setup
463 ipfiremake snort
464 ipfiremake snortsnarf
465 ipfiremake oinkmaster
466 ipfiremake squid
467 ipfiremake squid-graph
468 ipfiremake squidguard
469 ipfiremake calamaris
470 ipfiremake tcpdump
471 ipfiremake traceroute
472 ipfiremake vlan
473 ipfiremake wireless
474 ipfiremake libsafe
475 ipfiremake 3c5x9setup
476 ipfiremake pakfire
477 ipfiremake java
478 ipfiremake spandsp
479 ipfiremake lzo
480 ipfiremake openvpn
481 ipfiremake pammysql
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake bridge-utils
489 ipfiremake screen
490 ipfiremake hddtemp
491 ipfiremake smartmontools
492 ipfiremake htop
493 ipfiremake postfix
494 ipfiremake fetchmail
495 ipfiremake cyrusimap
496 ipfiremake webcyradm
497 ipfiremake mailx
498 ipfiremake clamav
499 ipfiremake spamassassin
500 ipfiremake amavisd
501 ipfiremake stund
502 ipfiremake libpri
503 # ipfiremake bristuff
504 ipfiremake asterisk
505 ipfiremake mpg123
506 ipfiremake mpfire
507 ipfiremake libmad
508 ipfiremake libogg
509 ipfiremake libvorbis
510 ipfiremake lame
511 ipfiremake sox
512 ipfiremake gnump3d
513 ipfiremake libsigc++
514 ipfiremake ctorrent
515 ipfiremake applejuice
516 ipfiremake ocaml
517 ipfiremake mldonkey
518 ipfiremake libtorrent
519 ipfiremake rtorrent
520 ipfiremake rsync
521 ipfiremake tcpwrapper
522 ipfiremake portmap
523 ipfiremake nfs
524 ipfiremake nmap
525 ipfiremake mbmon
526 ipfiremake iftop
527 ipfiremake ncftp
528 ipfiremake cftp
529 ipfiremake etherwake
530 ipfiremake ethereal
531 ipfiremake tftp-hpa
532 ipfiremake bwm-ng
533 ipfiremake tripwire
534 ipfiremake sysstat
535 ipfiremake vsftpd
536 ipfiremake alsa
537 ipfiremake mp3blaster
538 ipfiremake which
539 }
540
541 buildinstaller() {
542 # Run installer scripts one by one
543 LOGFILE="$BASEDIR/log/_build.installer.log"
544 export LOGFILE
545 ipfiremake syslinux
546 ipfiremake as86
547 ipfiremake mbr
548 ipfiremake memtest
549 installmake linux-libc-header
550 installmake binutils
551 ipfiremake uClibc PASS=1
552 ipfiremake gcc INST=1
553 installmake uClibc PASS=2
554 installmake gcc INST=2
555 installmake uClibc PASS=3
556 installmake busybox
557 installmake udev
558 installmake slang
559 installmake newt
560 installmake gettext
561 installmake kbd
562 installmake popt
563 installmake sysvinit
564 installmake misc-progs
565 installmake e2fsprogs
566 installmake libaal
567 installmake reiser4progs
568 installmake reiserfsprogs
569 installmake sysfsutils
570 installmake util-linux
571 installmake pciutils
572 installmake zlib
573 installmake mtd
574 installmake wget
575 installmake hwdata
576 installmake kudzu
577 installmake installer
578 installmake initrd
579 }
580
581 buildpackages() {
582 LOGFILE="$BASEDIR/log/_build.packages.log"
583 export LOGFILE
584 echo "... see detailed log in _build.*.log files" >> $LOGFILE
585
586 installmake strip
587
588 # Generating list of packages used
589 echo -n "Generating packages list from logs" | tee -a $LOGFILE
590 rm -f $BASEDIR/doc/packages-list
591 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
592 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
593 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
594 fi
595 done
596 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
597 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
598 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
599 rm -f $BASEDIR/doc/packages-list
600 # packages-list.txt is ready to be displayed for wiki page
601 beautify message DONE
602
603 # Create images for install
604 if [ "$DEVEL" == "1" ]; then
605 ipfiremake cdrom ED=devel
606 fi
607 ipfiremake cdrom ED=full
608
609 # Check if there is a loop device for building in virtual environments
610 if [ -e /dev/loop0 ]; then
611 ipfiremake usb-stick
612 fi
613 ipfiremake pxe
614 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
615
616 ipfirepackages
617
618 # Cleanup
619 stdumount
620 rm -rf $BASEDIR/build/tmp/*
621
622 # Generating total list of files
623 echo -n "Generating files list from logs" | tee -a $LOGFILE
624 rm -f $BASEDIR/log/FILES
625 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
626 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
627 echo "##" >>$BASEDIR/log/FILES
628 echo "## `basename $i`" >>$BASEDIR/log/FILES
629 echo "##" >>$BASEDIR/log/FILES
630 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
631 fi
632 done
633 beautify message DONE
634
635 cd $PWD
636 }
637
638 ipfirepackages() {
639 ipfiredist alsa
640 # ipfiredist amavisd
641 ipfiredist applejuice
642 # ipfiredist asterisk
643 ipfiredist clamav
644 ipfiredist cups
645 ipfiredist cyrus-sasl
646 # ipfiredist fetchmail
647 # ipfiredist gnump3d
648 ipfiredist java
649 ipfiredist libogg
650 ipfiredist libvorbis
651 # ipfiredist mailx
652 # ipfiredist mldonkey
653 ipfiredist mp3blaster
654 ipfiredist mpg123
655 # ipfiredist nfs
656 ipfiredist openldap
657 # ipfiredist postfix
658 ipfiredist samba
659 # ipfiredist sox
660 # ipfiredist spamassassin
661 ipfiredist tripwire
662 ipfiredist vsftpd
663 # ipfiredist webcyradm
664 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
665 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
666 rm -rf $BASEDIR/build/install/packages/*
667 }
668
669 # See what we're supposed to do
670 case "$1" in
671 build)
672 clear
673 BUILDMACHINE=`uname -m`
674 DEVEL=0
675 if [ "$2" == "--devel" ]; then
676 DEVEL=1
677 fi
678 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
679 #only restore on a clean disk
680 if [ ! -f log/cleanup-toolchain-2-tools ]; then
681 if [ ! -n "$PACKAGE" ]; then
682 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
683 prepareenv
684 buildtoolchain
685 else
686 PACKAGENAME=${PACKAGE%.tar.gz}
687 beautify build_stage "Packaged toolchain compilation"
688 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
689 tar zxf $PACKAGE
690 prepareenv
691 else
692 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
693 fi
694 fi
695 else
696 echo -n "Using installed toolchain" | tee -a $LOGFILE
697 beautify message SKIP
698 prepareenv
699 fi
700
701 beautify build_start
702 beautify build_stage "Building LFS"
703 buildbase
704
705 beautify build_stage "Building IPFire"
706 buildipfire
707
708 # Setzen des IPFire Builds
709 if [ "$FIREBUILD" ]; then
710 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
711 else
712 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
713 fi
714
715 beautify build_stage "Building installer"
716 buildinstaller
717
718 beautify build_stage "Building packages"
719 buildpackages
720 beautify build_end
721 ;;
722 shell)
723 # enter a shell inside LFS chroot
724 # may be used to changed kernel settings
725 prepareenv
726 entershell
727 ;;
728 changelog)
729 echo -n "Loading new Changelog from SVN: "
730 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
731 beautify message DONE
732 ;;
733 clean)
734 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
735 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
736 $LOSETUP -d $i 2>/dev/null
737 done
738 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
739 umount $i
740 done
741 stdumount
742 for i in `seq 0 7`; do
743 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
744 umount /dev/loop${i} 2>/dev/null;
745 losetup -d /dev/loop${i} 2>/dev/null;
746 fi;
747 done
748 rm -rf $BASEDIR/build
749 rm -rf $BASEDIR/cdrom
750 rm -rf $BASEDIR/packages
751 rm -rf $BASEDIR/log
752 if [ -h /tools ]; then
753 rm -f /tools
754 fi
755 beautify message DONE
756 ;;
757 downloadsrc)
758 if [ ! -d $BASEDIR/cache ]; then
759 mkdir $BASEDIR/cache
760 fi
761 mkdir -p $BASEDIR/log
762 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
763 FINISHED=0
764 cd $BASEDIR/lfs
765 for c in `seq $MAX_RETRIES`; do
766 if (( FINISHED==1 )); then
767 break
768 fi
769 FINISHED=1
770 cd $BASEDIR/lfs
771 for i in *; do
772 if [ -f "$i" -a "$i" != "Config" ]; then
773 echo -ne "Loading $i"
774 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
775 if [ $? -ne 0 ]; then
776 beautify message FAIL
777 FINISHED=0
778 else
779 if [ $c -eq 1 ]; then
780 beautify message DONE
781 fi
782 fi
783 fi
784 done
785 done
786 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
787 ERROR=0
788 for i in *; do
789 if [ -f "$i" -a "$i" != "Config" ]; then
790 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
791 if [ $? -ne 0 ]; then
792 echo -ne "MD5 difference in lfs/$i"
793 beautify message FAIL
794 ERROR=1
795 fi
796 fi
797 done
798 if [ $ERROR -eq 0 ]; then
799 echo -ne "${BOLD}all files md5sum match${NORMAL}"
800 beautify message DONE
801 else
802 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
803 beautify message FAIL
804 fi
805 cd - >/dev/null 2>&1
806 ;;
807 toolchain)
808 clear
809 prepareenv
810 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
811 buildtoolchain
812 BUILDMACHINE=`uname -m`
813 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
814 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
815 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
816 build/{bin,etc,usr/bin,usr/local} \
817 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
818 log >> $LOGFILE
819 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
820 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
821 stdumount
822 ;;
823 gettoolchain)
824 BUILDMACHINE=`uname -m`
825 # arbitrary name to be updated in case of new toolchain package upload
826 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
827 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
828 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
829 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
830 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
831 cd $BASEDIR/cache/toolchains
832 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
833 if [ $? -ne 0 ]; then
834 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
835 else
836 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
837 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
838 else
839 exiterror "$PACKAGE.md5 did not match, check downloaded package"
840 fi
841 fi
842 else
843 echo "Toolchain is already downloaded. Exiting..."
844 fi
845 ;;
846 othersrc)
847 prepareenv
848 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
849 chroot $LFS /tools/bin/env -i HOME=/root \
850 TERM=$TERM PS1='\u:\w\$ ' \
851 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
852 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
853 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
854 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
855 if [ $? -eq "0" ]; then
856 beautify message DONE
857 else
858 beautify message FAIL
859 fi
860 stdumount
861 ;;
862 svn)
863 case "$2" in
864 update|up)
865 # clear
866 echo -ne "Loading the latest source files...\n"
867 if [ $3 ]; then
868 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
869 else
870 svn update | tee -a $PWD/log/_build.svn.update.log
871 fi
872 if [ $? -eq "0" ]; then
873 beautify message DONE
874 else
875 beautify message FAIL
876 exit 1
877 fi
878 echo -ne "Writing the svn-info to a file"
879 svn info > $PWD/svn_status
880 if [ $? -eq "0" ]; then
881 beautify message DONE
882 else
883 beautify message FAIL
884 exit 1
885 fi
886 chmod 755 $0
887 exit 0
888 ;;
889 commit|ci)
890 clear
891 if [ -f /usr/bin/mcedit ]; then
892 export EDITOR=/usr/bin/mcedit
893 fi
894 if [ -f /usr/bin/nano ]; then
895 export EDITOR=/usr/bin/nano
896 fi
897 echo -ne "Selecting editor $EDITOR..."
898 beautify message DONE
899 if [ -e /sbin/yast ]; then
900 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
901 $0 changelog
902 fi
903 fi
904 update_langs
905 svn commit
906 $0 svn up
907 if [ -n "$FTP_CACHE_URL" ]; then
908 $0 uploadsrc
909 fi
910 ;;
911 dist)
912 if [ $3 ]; then
913 SVN_REVISION=$3
914 fi
915 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
916 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
917 exit 0
918 fi
919 echo -en "REV $SVN_REVISION: Downloading..."
920 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
921 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
922 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
923 evaluate 1
924
925 echo -en "REV $SVN_REVISION: Compressing files..."
926 if [ -e ipfire-source/trunk/make.sh ]; then
927 chmod 755 ipfire-source/trunk/make.sh
928 fi
929 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
930 evaluate 1
931 echo -en "REV $SVN_REVISION: Cleaning up..."
932 rm ipfire-source/ -r
933 evaluate 1
934 ;;
935 diff|di)
936 update_langs
937 echo -ne "Make a local diff to last svn revision"
938 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
939 evaluate 1
940 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
941 svn status
942 ;;
943 esac
944 ;;
945 uploadsrc)
946 PWD=`pwd`
947 cd $BASEDIR/cache/
948 echo -e "Uploading cache to ftp server:"
949 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
950 for i in *; do
951 if [ "$i" == "toolchains" ]; then continue; fi
952 grep -q $i /tmp/ftplist
953 if [ "$?" -ne "0" ]; then
954 echo -ne "$i"
955 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
956 if [ "$?" -ne "0" ]; then
957 beautify message FAIL
958 fi
959 fi
960 done
961 rm -f /tmp/ftplist
962 cd $PWD
963 exit 0
964 ;;
965 upload)
966 case "$2" in
967 iso)
968 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
969 cat <<EOF > .ftp-commands
970 mkdir -p $FTP_ISO_PATH$SVN_REVISION
971 ls -lah
972 quit
973 EOF
974 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
975 rm -f .ftp-commands
976 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
977 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
978 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
979 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
980 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
981 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
982 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
983 fi
984 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
985 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
986 if [ "$?" -eq "0" ]; then
987 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
988 else
989 echo -e "There was an error while uploading the iso to the ftp server."
990 exit 1
991 fi
992 if [ "$3" = "--with-sources-cd" ]; then
993 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
994 fi
995 ;;
996 paks)
997 cat <<EOF > .ftp-commands
998 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
999 ls -lah
1000 quit
1001 EOF
1002 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
1003 rm -f .ftp-commands
1004 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1005 if [ "$?" -eq "0" ]; then
1006 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1007 else
1008 echo -e "There was an error while uploading the packages to the ftp server."
1009 exit 1
1010 fi
1011 ;;
1012 esac
1013 ;;
1014 batch)
1015 if [ "$2" = "--background" ]; then
1016 batch_script
1017 exit $?
1018 fi
1019 if [ `screen -ls | grep -q ipfire` ]; then
1020 echo "Build is already running, sorry!"
1021 exit 1
1022 else
1023 if [ "$2" = "--rebuild" ]; then
1024 export IPFIRE_REBUILD=1
1025 echo "REBUILD!"
1026 else
1027 export IPFIRE_REBUILD=0
1028 fi
1029 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1030 screen -dmS ipfire $0 batch --background
1031 evaluate 1
1032 exit 0
1033 fi
1034 ;;
1035 watch)
1036 watch_screen
1037 ;;
1038 pxe)
1039 case "$2" in
1040 start)
1041 start_tftpd
1042 ;;
1043 stop)
1044 stop_tftpd
1045 ;;
1046 reload|restart)
1047 reload_tftpd
1048 ;;
1049 esac
1050 exit 0
1051 ;;
1052 lang)
1053 update_langs
1054 ;;
1055 packages)
1056 case "$2" in
1057 sign)
1058 sign_packages
1059 ;;
1060 esac
1061 ;;
1062 "")
1063 clear
1064 svn info
1065 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1066 do
1067 case $name in
1068 "IPFIRE: Downloadsrc")
1069 $0 downloadsrc
1070 ;;
1071 "IPFIRE: Build (silent)")
1072 $0 build-silent
1073 ;;
1074 "IPFIRE: Watch Build")
1075 $0 watch
1076 ;;
1077 "IPFIRE: Batch")
1078 $0 batch
1079 ;;
1080 "IPFIRE: Clean")
1081 $0 clean
1082 ;;
1083 "SVN: Update")
1084 $0 svn update
1085 ;;
1086 "Help")
1087 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1088 cat doc/make.sh-usage
1089 ;;
1090 "LOG: Tail")
1091 tail -f log/_*
1092 ;;
1093 "Exit")
1094 break
1095 ;;
1096 esac
1097 done
1098 ;;
1099 config)
1100 make_config
1101 ;;
1102 *)
1103 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1104 cat doc/make.sh-usage
1105 ;;
1106 esac